const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: false, name: '比赛管理', leftArrow: false, useBar: true },
        // 主体高度
        infoHeight: '',
        // 背景
        bg_1: '/image/match_1.png',
        bg_2: '/image/match_2.png',
        bg_3: '/image/match_3.png',
        pm_1: '/image/paiming.png',
        sp_1: '/image/shenpi.png',
        list: [],
        // 选项卡
        tabs: {
            active: '3',
            list: [
                { title: '进行中', name: '3' },
                { title: '未开始', name: '0' },
                { title: '已结束', name: '4' },
            ],
        },
    },
    back: function () {
        wx.navigateBack({ url: '/pages/home/index' })
    },
    tabPath: function (e) {
        let { route } = e.detail.detail;
        if (route) wx.redirectTo({ url: `/${route}` })
    },
    // 选项卡
    tabsChange: function (e) {
        const that = this;
        that.setData({ 'tabs.active': e.detail.name })
        that.watchLogin();
    },
    // 公共路由跳转方法
    toCommon: function (e) {
        const { route } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/${route}/index` })
    },
    // 查看比赛信息
    toView: function (e) {
        const { id } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/match/info?id=${id}` })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        // 计算高度
        this.searchHeight();
        // 监听用户是否登录
        this.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: function () {
        const that = this;
        let status = that.data.tabs.active;
        wx.getStorage({
            key: 'token',
            success: async res => {
                const arr = await app.$get(`/courtAdmin/api/match`, { status: status })
                if (arr.errcode == '0') that.setData({ list: arr.data })
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    // 计算高度
    searchHeight: function () {
        let frameStyle = this.data.frameStyle;
        let client = app.globalData.client;
        let infoHeight = client.windowHeight;
        // 是否去掉状态栏
        if (frameStyle.useTop) infoHeight = infoHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
        // 是否减去底部菜单
        if (frameStyle.useBar) infoHeight = infoHeight - 50;
        if (infoHeight) this.setData({ infoHeight: infoHeight })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})