const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: false, name: '首页', leftArrow: false, useBar: true },
        // 主体高度
        infoHeight: '',
        // 首页背景
        homeBg: '/image/home_1.png',
        // 比赛列表
        list: []
    },
    back: function () {
        wx.navigateBack({ url: '/pages/home/index' })
    },
    tabPath: function (e) {
        let { route } = e.detail.detail;
        if (route) wx.redirectTo({ url: `/${route}` })
    },
    // 查看比赛信息
    toView: function (e) {
        const { id } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/match/info?id=${id}` })
    },
    // 查看比赛信息
    scheduleView: function (e) {
        const { id } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/match/schedule?id=${id}` })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        // 计算高度
        this.searchHeight();
        // 监听用户是否登录
        this.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: function () {
        const that = this;
        wx.getStorage({
            key: 'token',
            success: async res => {
                const arr = await app.$get(`/courtAdmin/api/match`);
                if (arr.errcode == '0') {
                    for (const val of arr.data) {
                        if (val.status == '3') {
                            const aee = await app.$get('/courtAdmin/api/schedule', { match_id: val._id });
                            if (aee.errcode == '0') val.schedulelist = aee.data;
                        }
                    }
                    that.setData({ list: arr.data })
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    // 计算高度
    searchHeight: function () {
        let frameStyle = this.data.frameStyle;
        let client = app.globalData.client;
        let infoHeight = client.windowHeight;
        // 是否去掉状态栏
        if (frameStyle.useTop) infoHeight = infoHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
        // 是否减去底部菜单
        if (frameStyle.useBar) infoHeight = infoHeight - 50;
        if (infoHeight) this.setData({ infoHeight: infoHeight })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})