// pages/login/login.js
import WxValidate from '../../utils/wxValidate'
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '赛程信息', leftArrow: true, useBar: false },
        // 主体高度
        infoHeight: '',
        // 比赛信息
        match_id: '',
        matchInfo: {},
        list: [],
        // 弹框
        dialog: { title: '详细信息', show: false, type: '1' },
        //详情
        form: {},
        // 状态
        statusList: [{ label: '未开始', value: '0' }, { label: '进行中', value: '1' }, { label: '已结束', value: '2' }],
    },
    back: function () {
        wx.navigateBack({ url: '/pages/matchadmin/index' })
    },
    // 添加
    toAdd: function () {
        const that = this;
        wx.navigateTo({ url: `/pages/matchadmin/layout?id=${that.data.match_id}` })
    },
    // 查看
    toView: async function (e) {
        const that = this;
        let { id } = e.currentTarget.dataset;
        const arr = await app.$get(`/courtAdmin/api/schedule/${id}`);
        if (arr.errcode == '0') {
            that.setData({ form: arr.data })
            that.setData({ dialog: { title: '详细信息', show: true, type: '1' } })
        }
    },
    //比赛进度
    toEdit: async function (e) {
        const that = this;
        let { id } = e.currentTarget.dataset;
        // wx.navigateTo({ url: `/pages/matchadmin/layout?info_id=${id}&id=${that.data.match_id}` })
        const arr = await app.$get(`/courtAdmin/api/schedule/${id}`);
        if (arr.errcode == '0') {
            that.setData({ form: arr.data })
            that.setData({ dialog: { title: '比赛进度', show: true, type: '2' } })
        }
    },
    // 选择状态
    statusChange: function (e) {
        const that = this;
        const { value } = e.detail;
        that.setData({ 'form.status': value })
    },
    // 提交
    onSubmit: async function (e) {
        const that = this;
        const data = that.data.form;
        const params = e.detail.value;
        const arr = await app.$post(`/courtAdmin/api/schedule/${data.id}`, params);
        if (arr.errcode == '0') {
            wx.showToast({ title: `维护信息成功`, icon: 'error', duration: 2000 });
            that.toClose();
            that.watchLogin();
        } else wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
    },
    // 维护赛程信息
    toRace: function (e) {
        const { id } = e.currentTarget.dataset;
        wx.navigateTo({ url: `/pages/matchadmin/layoutdetail?id=${id}` })
    },
    toClose: function () {
        const that = this;
        that.setData({ dialog: { title: '详细信息', show: false, } })
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ match_id: options.id || '629eb5de78fa03648c0535d9' })
        // 计算高度
        this.searchHeight();
        // 监听用户是否登录
        this.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: function () {
        const that = this;
        wx.getStorage({
            key: 'token',
            success: async res => {
                let arr;
                // 查询比赛信息
                arr = await app.$get(`/courtAdmin/api/match/${that.data.match_id}`,);
                if (arr.errcode == '0') that.setData({ matchInfo: arr.data });
                // 查询赛制信息
                arr = await app.$get(`/courtAdmin/api/schedule`, { match_id: that.data.match_id });
                if (arr.errcode == '0') that.setData({ list: arr.data });
            },
            fail: res => {
                return wx.redirectTo({ url: '/pages/login/index', })
            }
        })
    },
    // 计算高度
    searchHeight: function () {
        let frameStyle = this.data.frameStyle;
        let client = app.globalData.client;
        let infoHeight = client.windowHeight;
        // 是否去掉状态栏
        if (frameStyle.useTop) infoHeight = infoHeight - (client.statusBarHeight + client.getMenu.height + (client.getMenu.top - client.statusBarHeight) * 2);
        // 是否减去底部菜单
        if (frameStyle.useBar) infoHeight = infoHeight - 50;
        if (infoHeight) this.setData({ infoHeight: infoHeight })
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})